diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index 83e08154c..79eaa680a 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -31,7 +31,7 @@ public abstract class Achievements
             .registerAchievement();
     public static Achievement DOWN_THE_DRAIN =
             new Achievement(NamespaceID.fromPool("minecraft", "down_the_drain"), "downTheDrain", Blocks.MESH, ACQUIRE_IRON)
-                    .registerAchievement();
+            .registerAchievement();
     public static Achievement GET_DIAMONDS =
         new Achievement(NamespaceID.fromPool("minecraft", "get_diamonds"), "getDiamonds", Items.DIAMOND, ACQUIRE_IRON)
             .setType(Achievement.TYPE_SPECIAL)
@@ -118,35 +118,95 @@ public abstract class Achievements
 
     // Nether achievements
     public static Achievement ENTER_NETHER =
-        new Achievement(NamespaceID.fromPool("minecraft", "enter_nether"), "enterNether", Blocks.OBSIDIAN, null)
+        new Achievement(NamespaceID.fromPool("minecraft", "enter_nether"), "enterNether", Blocks.NETHERRACK, null)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement GET_NETHERCOAL =
         new Achievement(NamespaceID.fromPool("minecraft", "get_nethercoal"), "getNethercoal", Items.NETHERCOAL, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
+    public static Achievement DISCOVER_SULFURPOOLS =
+        new Achievement(NamespaceID.fromPool("minecraft", "discover_sulfurpools"), "discoverSulfurPools", Blocks.BRIMTHAW, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement();
+    public static Achievement DISCOVER_VOLCANICISLANDS =
+        new Achievement(NamespaceID.fromPool("minecraft", "discover_volcanicislands"), "discoverVolcanicIslands", Blocks.MAGMA, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement();
+    public static Achievement FLING_VENT =
+        new Achievement(NamespaceID.fromPool("minecraft", "flingVent"), "flingVent", Items.GUNPOWDER, DISCOVER_VOLCANICISLANDS)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement COLLECT_PUMICE =
+        new Achievement(NamespaceID.fromPool("minecraft", "collect_pumice"), "collectPumice", Blocks.PUMICE_WET, DISCOVER_VOLCANICISLANDS)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement WHAT_WAS_THAT =
+        new Achievement(NamespaceID.fromPool("minecraft", "explode_stacked_vent"), "explodeStackedVent", Blocks.THERMAL_VENT, DISCOVER_VOLCANICISLANDS)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement DISCOVER_CRYSTALFOREST =
+        new Achievement(NamespaceID.fromPool("minecraft", "discover_crystalforest"), "discoverCrystalForest", Blocks.RUBYGLASS_COLUMN, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement();
+    public static Achievement COLLECT_RUBYGLASS =
+        new Achievement(NamespaceID.fromPool("minecraft", "collect_rubyglass"), "collectRubyglass", Items.RUBYGLASS, DISCOVER_CRYSTALFOREST)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement CRAFT_CONDUIT =
+        new Achievement(NamespaceID.fromPool("minecraft", "craft_conduit"), "craftConduit", Blocks.CONDUIT, COLLECT_RUBYGLASS)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement DISCOVER_OLDWORLD =
+        new Achievement(NamespaceID.fromPool("minecraft", "discover_oldworld"), "discoverOldWorld", Blocks.BLOCK_ASH, ENTER_NETHER)
+            .setType(Achievement.TYPE_SPECIAL)
+            .registerAchievement();
+    public static Achievement TRIGGER_EMBER =
+        new Achievement(NamespaceID.fromPool("minecraft", "trigger_ember"), "triggerEmber", Blocks.EMBER, null)
+            .setType(Achievement.TYPE_SECRET)
+            .registerAchievement();
+    public static Achievement COLLECT_ACID =
+        new Achievement(NamespaceID.fromPool("minecraft", "collect_acid"), "collectAcid", ItemBucket.createItemStack(Items.BUCKET_IRON, ItemBucket.STATE_ACID, 1), DISCOVER_SULFURPOOLS)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement CONVERT_ACID_TO_SULFUR =
+        new Achievement(NamespaceID.fromPool("minecraft", "acid_sulfur_conversion"), "acidSulfurConversion", Blocks.SULFUR, COLLECT_ACID)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement CONVERT_ACID_TO_STONE =
+        new Achievement(NamespaceID.fromPool("minecraft", "acid_stone_generation"), "acidStoneGeneration", Blocks.STONE, COLLECT_ACID)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement CRAFT_ACID_COBBLE_TO_STONE =
+        new Achievement(NamespaceID.fromPool("minecraft", "acid_cobble_conversion"), "acidCobbleConversion", Blocks.COBBLE_STONE, COLLECT_ACID)
+            .setType(Achievement.TYPE_NORMAL)
+            .registerAchievement();
+    public static Achievement ACID_BATH =
+        new Achievement(NamespaceID.fromPool("minecraft", "acid_bath"), "acidBath", ItemBucket.createItemStack(Items.BUCKET_STEEL, ItemBucket.STATE_ACID, 3), null)
+            .setType(Achievement.TYPE_SECRET)
+            .registerAchievement();
     public static Achievement LIGHT_SIGN =
         new Achievement(NamespaceID.fromPool("minecraft", "light_sign"), "lightSign", Items.DUST_GLOWSTONE, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement SWIM_NETHER =
-        new Achievement(NamespaceID.fromPool("minecraft", "swim_nether"), "swimNether", ItemBucket.createItemStack(Items.BUCKET_IRON, ItemBucket.STATE_WATER, 1), ENTER_NETHER)
-            .setType(Achievement.TYPE_SPECIAL)
+        new Achievement(NamespaceID.fromPool("minecraft", "swim_nether"), "swimNether", Blocks.RUBYGLASS_CRYSTAL, ENTER_NETHER)
+            .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static Achievement HIT_FIREBALL =
         new Achievement(NamespaceID.fromPool("minecraft", "hit_fireball"), "hitFireball", Items.AMMO_FIREBALL, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
     public static Achievement SLEEP_NETHER =
-        new Achievement(NamespaceID.fromPool("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
-            .setType(Achievement.TYPE_SPECIAL)
+        new Achievement(NamespaceID.fromPool("minecraft", "sleep_nether"), "sleepNether", Items.BED, null)
+            .setType(Achievement.TYPE_SECRET)
             .registerAchievement();
     public static Achievement MOST_WANTED =
         new Achievement(NamespaceID.fromPool("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
-    public static Achievement FAST_TRAVEL = // TODO
-        new Achievement(NamespaceID.fromPool("minecraft", "fast_travel"), "fastTravel", Blocks.GRASS, ENTER_NETHER)
+    public static Achievement FAST_TRAVEL =
+        new Achievement(NamespaceID.fromPool("minecraft", "fast_travel"), "fastTravel", Blocks.OBSIDIAN, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
             .registerAchievement();
     public static final Achievement GET_STEEL_BLAST_FURNACE =
@@ -156,6 +216,9 @@ public abstract class Achievements
     public static final Achievement OBTAIN_STEEL =
         new Achievement(NamespaceID.fromPool("minecraft", "obtain_steel"), "obtainSteel", Items.INGOT_STEEL, GET_STEEL_BLAST_FURNACE)
             .registerAchievement();
+    public static final Achievement CRAFT_STEEL_BUCKET =
+        new Achievement(NamespaceID.fromPool("minecraft", "craft_steel_bucket"), "craftSteelBucket", Items.BUCKET_STEEL, OBTAIN_STEEL)
+            .registerAchievement();
 
     public static void init(){};
 }
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
index 1b9a6ece7..2f903e673 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/stat/StatsCounter.java
@@ -50,9 +50,26 @@ public class StatsCounter {
 		modified = true;
 	}
 
+	public void remove(Stat stat) {
+		if (stat == null) {
+			return;
+		}
+		if (!sessionStats.containsKey(stat) && !savedStats.containsKey(stat)) {
+			return;
+		}
+		sessionStats.removeInt(stat);
+		savedStats.removeInt(stat);
+		modified = true;
+	}
+
 	private void addToMap(Object2IntMap<Stat> map, Stat stat, int amount) {
 		int currentValue = map.getOrDefault(stat, 0);
-		map.put(stat, currentValue + amount);
+		int newValue = currentValue + amount;
+		if (newValue <= 0) {
+			map.removeInt(stat);
+		} else {
+			map.put(stat, newValue);
+		}
 	}
 
 	@Unmodifiable
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
index e32631874..525836a0b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicEmber.java
@@ -1,19 +1,17 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.animal.MobWolf;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.joml.Vector3d;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
@@ -26,19 +24,15 @@ public class BlockLogicEmber extends BlockLogic {
 
 	@Override
 	public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
-		if(entity instanceof Player || entity instanceof MobWolf){
-			this.ignite(world, tilePos, entity);
-		}
-	}
-
-	@Override
-	public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
-		if(entity instanceof Player || entity instanceof MobWolf){ // We do a little trolling here...
+		if(!world.isClientSide && (entity instanceof Player || entity instanceof MobWolf)){
 			this.ignite(world, tilePos, entity);
 		}
 	}
 
 	public void ignite(@NotNull World world, @NotNull TilePosc tilePos, Entity entity) {
+		if (!world.isClientSide && entity instanceof Player player) {
+			player.addStat(Achievements.TRIGGER_EMBER, 1);
+		}
 		if (entity != null) {
 			entity.hurt(null, 8, DamageType.BLAST);
 			entity.remainingFireTicks = 100;
@@ -85,4 +79,10 @@ public class BlockLogicEmber extends BlockLogic {
 			world.spawnParticle("largesmoke", xPos, yPos + 0.30, zPos, 0.0F, 0.015F, 0.0F, 0, false);
 		}
 	}
+
+	@Override
+	public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+		double f = 0.25/16d; // TODO making the hitbox slightly shorter so `onEntityCollision` triggers consistently, need a method that actually reliably is called when walked on or touched `onEntityWalkedOn` is only applied when its the block responsible for footstep noises and `onEntityCollision` only happens consistently when intersecting the bounds of a block
+		return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1, tilePos.y() + 1 - f, tilePos.z() + 1);
+	}
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index f969d4b79..e7428b752 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -120,7 +120,7 @@ public abstract class BlockLogicFluid extends BlockLogic {
 
     @Override
     public void onEntityInside(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity, @NotNull Vector3d velocityDirection) {
-        if (entity.noPhysics) return;
+        if (entity.hasNoPhysics()) return;
         velocityDirection.add(getFlow(world, tilePos));
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 3acad5f13..29190bc4f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -3,24 +3,24 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+
+import java.util.Arrays;
 import java.util.Random;
 
 public class BlockLogicFluidFlowing extends BlockLogicFluid {
     int maxCount;
-    boolean @NotNull [] result;
-    int @NotNull [] distance;
     public final @NotNull Block<?> blockStill;
 
     public BlockLogicFluidFlowing(@NotNull Block<?> block, @NotNull Material material, final @NotNull Fluid fluid, @NotNull Block<?> blockStill) {
         super(block, material, fluid);
         this.maxCount = 0;
-        this.result = new boolean[4];
-        this.distance = new int[4];
         this.blockStill = blockStill;
     }
 
@@ -69,7 +69,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
                 } else {
                     world.setBlockDataNotify(tilePos, localFlowDecay);
                     world.scheduleBlockUpdate(tilePos, this.block, tickDelay(world, tilePos));
-                    world.notifyBlocksOfNeighborChange(tilePos, this.block);
+                    // world.notifyBlocksOfNeighborChange(tilePos, this.block);
                 }
             } else {
                 setFluidStill(world, tilePos);
@@ -78,39 +78,30 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
             setFluidStill(world, tilePos);
         }
         if (canSpreadTo(world, tilePos.down(queryPos))) {
-            Block<?> b = world.getBlockType(tilePos.down(queryPos));
+            final TilePosc spreadPos = tilePos.down(queryPos);
+            Block<?> b = world.getBlockType(spreadPos);
             if (b != null) {
-                b.dropWithCause(world, EnumDropCause.WORLD, tilePos.down(queryPos), world.getBlockData(tilePos.down(queryPos)), null, null);
+                b.dropWithCause(world, EnumDropCause.WORLD, spreadPos, world.getBlockData(spreadPos), null, null);
             }
             if (localFlowDecay >= 8) {
-                world.setBlockTypeDataNotify(tilePos.down(queryPos), this.block, localFlowDecay);
+                world.setBlockTypeDataNotify(spreadPos, this.block, localFlowDecay);
             } else {
-                world.setBlockTypeDataNotify(tilePos.down(queryPos), this.block, localFlowDecay + 8);
+                world.setBlockTypeDataNotify(spreadPos, this.block, localFlowDecay + 8);
             }
         } else if (localFlowDecay >= 0 && (localFlowDecay == 0 || isFluidBlocking(world, tilePos.down(queryPos)))) {
-            boolean[] spreadFlags = getSpread(world, tilePos);
-            int k1 = localFlowDecay + flowDecayMod;
-            if (localFlowDecay >= 8) {
-                k1 = 1;
-            }
-            if (k1 >= 8) {
-                return;
-            }
-            if (spreadFlags[0]) {
-                flowIntoBlock(world, tilePos.west(queryPos), k1);
-            }
-            if (spreadFlags[1]) {
-                flowIntoBlock(world, tilePos.east(queryPos), k1);
-            }
-            if (spreadFlags[2]) {
-                flowIntoBlock(world, tilePos.north(queryPos), k1);
-            }
-            if (spreadFlags[3]) {
-                flowIntoBlock(world, tilePos.south(queryPos), k1);
-            }
+            final int meta = (localFlowDecay < MAX_SPREAD)
+                ? localFlowDecay + flowDecayMod
+                : 1;
+            final int spreadDistance = (MAX_SPREAD - localFlowDecay) / flowDecayMod - 1;
+            if (spreadDistance <= 0) return;
+
+            final byte spreadFlags = getSpreadDirections(world, tilePos, spreadDistance);
+            if ((spreadFlags & MASK_W) != 0) flowIntoBlock(world, tilePos.west(queryPos), meta);
+            if ((spreadFlags & MASK_E) != 0) flowIntoBlock(world, tilePos.east(queryPos), meta);
+            if ((spreadFlags & MASK_N) != 0) flowIntoBlock(world, tilePos.north(queryPos), meta);
+            if ((spreadFlags & MASK_S) != 0) flowIntoBlock(world, tilePos.south(queryPos), meta);
         }
     }
-
     private void flowIntoBlock(@NotNull World world, @NotNull TilePos tilePos, int meta) {
         if (canSpreadTo(world, tilePos)) {
             this.fluid.onFlowIntoBlock(this, world, tilePos, meta);
@@ -118,79 +109,188 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid {
         }
     }
 
-    private int getSlopeDistance(@NotNull World world, @NotNull TilePosc tilePos, int l, int i1) {
-        int j1 = 1000;
-        TilePos queryPos = new TilePos(tilePos);
-        for (int d = 0; d < 4; d++) {
-            if (d == 0 && i1 == 1 || d == 1 && i1 == 0 || d == 2 && i1 == 3 || d == 3 && i1 == 2) {
-                continue;
-            }
-            int checkX = tilePos.x();
-            int checkY = tilePos.y();
-            int checkZ = tilePos.z();
-            switch (d) {
-                case 0 -> checkX--;
-                case 1 -> checkX++;
-                case 2 -> checkZ--;
-                case 3 -> checkZ++;
-            }
-            queryPos.set(checkX, checkY, checkZ);
-            if (isFluidBlocking(world, queryPos) || world.getBlockMaterial(queryPos) == this.material && world.getBlockData(queryPos) == 0) {
-                continue;
-            }
-            if (!isFluidBlocking(world, queryPos.set(checkX, checkY - 1, checkZ))) {
-                return l;
-            }
-            if (l >= this.fluid.getMaxHorizontalSpread(this, world, tilePos)) {
-                continue;
-            }
-            int k2 = getSlopeDistance(world, queryPos.set(checkX, checkY, checkZ), l + 1, d);
-            if (k2 < j1) {
-                j1 = k2;
-            }
-        }
+    private static final int MAX_SPREAD = 8;
+    private static final int POS_OBSTRUCTED = Integer.MAX_VALUE, POS_EMPTY = Integer.MAX_VALUE - 1;
+
+    private static final byte MASK_W = 0b0001, MASK_E = 0b0010, MASK_N = 0b0100, MASK_S = 0b1000;
+    private static final int INDEX_W = pos2index(-1, 0), INDEX_E = pos2index(+1, 0), INDEX_N = pos2index(0, -1), INDEX_S = pos2index(0, +1);
 
-        return j1;
+    private static final int[] MAP_1 = new int[256];
+    private static final IntArrayList BUF_1 = new IntArrayList();
+    private static final IntArrayList BUF_2 = new IntArrayList();
+
+    private static final int pos2index(final int x, final int z) {
+        assert Math.abs(x) < 8 && Math.abs(z) < 8;
+        return ((x & 0xF)) | ((z & 0xF) << 4);
     }
 
-    private boolean[] getSpread(@NotNull World world, @NotNull TilePosc tilePos) {
-        TilePos queryPos = new TilePos(tilePos);
-        for (int d = 0; d < 4; d++) {
-            this.distance[d] = 1000;
-            int checkX = tilePos.x();
-            int checkY = tilePos.y();
-            int checkZ = tilePos.z();
-            switch (d) {
-                case 0 -> checkX--;
-                case 1 -> checkX++;
-                case 2 -> checkZ--;
-                case 3 -> checkZ++;
-            }
-            queryPos.set(checkX, checkY, checkZ);
-            if (isFluidBlocking(world, queryPos) || world.getBlockMaterial(queryPos) == this.material && world.getBlockData(queryPos) == 0) {
-                continue;
+    private static int x, z;
+    private static final void index2pos(final int i) {
+        x = (i) & 0xF;
+        z = (i>>4) & 0xF;
+        if (x >= 8) x |= -8;
+        if (z >= 8) z |= -8;
+    }
+
+    private byte getSpreadDirections(@NotNull World world, @NotNull TilePosc tilePos, int spreadDistance) {
+        assert spreadDistance >= 0 && spreadDistance < MAX_SPREAD;
+
+        final int ox = tilePos.x();
+        final int oz = tilePos.z();
+        final int oy = tilePos.y();
+
+        BUF_1.clear();
+        BUF_2.clear();
+        final var holeBuf = BUF_1;
+        final var obstacleBuf = BUF_2;
+        final var distanceMap = MAP_1;
+        Arrays.fill(distanceMap, POS_EMPTY);
+
+        final var queryPos = new TilePos();
+        byte neighboringObstaclesMask = 0b0000;
+
+        int layer;
+        for (layer = 1; layer <= spreadDistance; layer++) {
+            final int obstaclesBeforeLayer = obstacleBuf.size();
+
+            for (int x = -layer; x <= layer; x++) {
+                final int rz = layer - Math.abs(x);
+                for (int z = -rz;; z = rz) {
+                    queryPos.set(ox + x, oy, oz + z);
+                    final int i = pos2index(x, z);
+
+                    check: {
+                        final boolean isObstructed; isObstructed: {
+                            final Block<?> b = world.getBlockType(queryPos);
+                            if (b == Blocks.AIR) {
+                                isObstructed = false; break isObstructed;
+                            }
+                            final boolean isFluidBlocking = 
+                               !(b.getLogic() instanceof BlockLogicFluid) &&
+                               !b.hasTag(BlockTags.BROKEN_BY_FLUIDS) &&
+                               !b.hasTag(BlockTags.PLACE_OVERWRITES);
+                            if (isFluidBlocking) {
+                                isObstructed = true; break isObstructed;
+                            }
+        
+                            final boolean isMatchingSource =
+                                b.getMaterial() == this.material &&
+                                world.getBlockData(queryPos) == 0;
+                            isObstructed = isMatchingSource;
+                        }
+                        if (isObstructed) {
+                            obstacleBuf.add(i);
+                            distanceMap[i] = POS_OBSTRUCTED;
+                            if (layer != 1) break check;
+
+                            if (x != 0) {
+                                assert Math.abs(x) == 1 && z == 0;
+                                neighboringObstaclesMask |= (x == -1) ? MASK_W : MASK_E;
+                            } else {
+                                assert Math.abs(z) == 1 && x == 0;
+                                neighboringObstaclesMask |= (z == -1) ? MASK_N : MASK_S;
+                            }
+                            break check;
+                        }
+ 
+                        final boolean isHole; isHole: {
+                            final Block<?> b = world.getBlockType(queryPos.down());
+                            if (b == Blocks.AIR) {
+                                isHole = true; break isHole;
+                            }
+                            final boolean isFluidBlocking = 
+                               !(b.getLogic() instanceof BlockLogicFluid) &&
+                               !b.hasTag(BlockTags.BROKEN_BY_FLUIDS) &&
+                               !b.hasTag(BlockTags.PLACE_OVERWRITES);
+                            isHole = !isFluidBlocking;
+                        }
+                        if (isHole) {
+                            holeBuf.add(i);
+                            distanceMap[i] = 0;
+                            break check;
+                        }
+                    }
+
+                    // iterate once if rz == 0, twice otherwise
+                    if (z == rz) break;
+                }
             }
-            if (!isFluidBlocking(world, queryPos.set(checkX, checkY - 1, checkZ))) {
-                this.distance[d] = 0;
-            } else {
-                this.distance[d] = getSlopeDistance(world, queryPos.set(checkX, checkY, checkZ), 1, d);
+
+            final int blocksThisLayer = 4*layer;
+            final int holesThisLayer = holeBuf.size();
+
+            // no obstacles nor holes were found before this layer, therefore
+            // 1) holes this layer are the closest holes,
+            // 2) distance to holes is simply manhattan distance.
+            if (obstaclesBeforeLayer == 0 && holesThisLayer != 0) {
+                if (holesThisLayer == blocksThisLayer) return 0b1111;
+                byte mask = 0b0000;
+                for (int _i = 0; _i < holeBuf.size(); _i++) {
+                    /*x, z =*/ index2pos(holeBuf.getInt(_i));
+                    if (x != 0) mask |= (x < 0) ? MASK_W : MASK_E;
+                    if (z != 0) mask |= (z < 0) ? MASK_N : MASK_S;
+                }
+                return mask;
             }
+
+            // every block in this layer are obstacles,
+            // therefore no point in continuing the search
+            if (obstacleBuf.size() - obstaclesBeforeLayer == blocksThisLayer) break;
         }
 
-        int i1 = this.distance[0];
-        for (int k1 = 1; k1 < 4; k1++) {
-            if (this.distance[k1] < i1) {
-                i1 = this.distance[k1];
+        // there exist no reachable holes, therefore we only care about adjacent obstacles
+        if (holeBuf.size() == 0) return (byte)~neighboringObstaclesMask;
+
+        // there exist some holes that are potentially obstructed.
+        // calculate the distance map with BFS from holes
+        final var updateBuf = holeBuf;
+        for (int _i = 0; _i < updateBuf.size(); _i++) {
+            final int i = updateBuf.getInt(_i);
+            final int d = distanceMap[i];
+            if (d == POS_OBSTRUCTED) continue;
+            /*x, z =*/ index2pos(i);
+
+            for (int q = 0; q < 4; q++) {
+                int x2 = x, z2 = z;
+                switch (q) {
+                    case 0 -> { x2 -= 1; }
+                    case 1 -> { x2 += 1; }
+                    case 2 -> { z2 -= 1; }
+                    case 3 -> { z2 += 1; }
+                }
+                final int od = Math.abs(x2) + Math.abs(z2);
+
+                // we do not update distances outside the current searched diamond,
+                // nor do we update distances across the origin (this makes the distance values
+                // across the origin incorrect, but does not change the comparison results).
+                if (od >= layer || od == 0) continue;
+
+                final int i2 = pos2index(x2, z2);
+                final int d2 = distanceMap[i2];
+
+                if (d2 == POS_OBSTRUCTED) continue;
+                if (d2 > d + 1) {
+                    distanceMap[i2] = d + 1;
+                    updateBuf.push(i2);
+                }
             }
         }
 
-        for (int l1 = 0; l1 < 4; l1++) {
-            this.result[l1] = this.distance[l1] == i1;
-        }
+        final int dW = distanceMap[INDEX_W];
+        final int dE = distanceMap[INDEX_E];
+        final int dN = distanceMap[INDEX_N];
+        final int dS = distanceMap[INDEX_S];
 
-        return this.result;
-    }
+        final int dm = Math.min(Math.min(dW, dE), Math.min(dN, dS));
+        byte mask = 0;
+        if (dW == dm) mask |= 0b0001;
+        if (dE == dm) mask |= 0b0010;
+        if (dN == dm) mask |= 0b0100;
+        if (dS == dm) mask |= 0b1000;
 
+        return mask;
+    }
+ 
     private boolean isFluidBlocking(@NotNull World world, @NotNull TilePos tilePos) {
         Block<?> b = world.getBlockType(tilePos);
         return !(b.getLogic() instanceof BlockLogicFluid) && !b.hasTag(BlockTags.BROKEN_BY_FLUIDS) && !b.hasTag(BlockTags.PLACE_OVERWRITES);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
index 8e8075dc0..f8ce3cecf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRotatable.java
@@ -9,7 +9,7 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public abstract class BlockLogicRotatable extends BlockLogic {
+public class BlockLogicRotatable extends BlockLogic {
     public static final int MASK_DIRECTION = 0b0000_0111;
 
     public BlockLogicRotatable(@NotNull Block<?> block, @NotNull Material material) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
index 4ce22dac6..41ff6a93b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrystal.java
@@ -44,11 +44,6 @@ public class BlockLogicRubyglassCrystal extends BlockLogicTransparent {
 		if (data == 0) world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
 	}
 
-	@Override
-	public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
-		this.onEntityCollision(world, tilePos, entity);
-	}
-
 	@Override
 	public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
 		return 0.0F;
@@ -93,7 +88,7 @@ public class BlockLogicRubyglassCrystal extends BlockLogicTransparent {
 
 	@Override
 	public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-		double f = 0.25/16d; // TODO making the hitbox slightly shorter so `onEntityWalkedOn` triggers consistently, need a method that actually reliably is called when walked on or touched `onEntityWalkedOn` is only applied when its the block responsible for footstep noises and `onEntityWalkedOn` only happens consistently when intersecting the bounds of a block
+		double f = 0.25/16d; // TODO making the hitbox slightly shorter so `onEntityCollision` triggers consistently, need a method that actually reliably is called when walked on or touched `onEntityWalkedOn` is only applied when its the block responsible for footstep noises and `onEntityCollision` only happens consistently when intersecting the bounds of a block
 		return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1, tilePos.y() + 1 - f, tilePos.z() + 1);
 	}
 
